﻿/*
 * scraep - robust 4chan thread watcher
 * Copyright (C) 2010  ed <tripflag@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License v2
 * (version 2) as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, refer to the following URL:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt
 */
using System;
using System.Collections.Generic;
using System.Text;

namespace scraep {
    class Downloader {
        bool downloading;
        List<Image> images;
        public Downloader() {
            images = new List<Image>();
            System.Threading.Thread runner = new System.Threading.Thread(new System.Threading.ThreadStart(core));
            runner.IsBackground = true;
            runner.Start();
        }
        public void add(Image[] image) {
            foreach (Image i in image)
                if (!i.exists())
                    images.Add(i);
        }
        void core() {
            while (true) {
                if (images.Count > 0) {
                    downloading = true;
                    Image image = images[0];
                    images.RemoveAt(0);
                    if (!image.exists()) {
                        if (image.download()) {
                            if (!image.verify()) {
                                image.delete();
                            }
                        }
                    }
                    downloading = false;
                }
                System.Threading.Thread.Sleep(10);
            }
        }
        public int remain() {
            return images.Count + (downloading? 1 : 0);
        }
    }
}
